// ---------------------------------------------------------------------------
//    SMA   .
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_width1  2
#property indicator_color1  SeaGreen
#property indicator_minimum 0

//  .
extern int SMA_PERIOD   = 20;
//  .
extern int COUNT_PERIOD = 240;

//  .
double buf_bend[], buf_count[];
//   .
int work_period1, work_period2;

// .
int init() {
  IndicatorShortName(StringConcatenate(
    "AZZX - BEND COUNTER v1.0 (", SMA_PERIOD, ", ", COUNT_PERIOD, ")"));
  IndicatorBuffers(2);
  IndicatorDigits(0);
  
  SetIndexBuffer(0, buf_count);
  SetIndexBuffer(1, buf_bend);
  SetIndexLabel(0, "BEND COUNTER");

  work_period1 = Bars - SMA_PERIOD - 1;
  work_period2 = work_period1 - COUNT_PERIOD;

  return(0);
}

//  .
int start() {
  for(int i = Bars - IndicatorCounted() - 1; i >= 1; i--) {
    //  .
    if(i < work_period1) {
      double p0 = iMA(NULL, 0, SMA_PERIOD, 0, MODE_SMA, PRICE_CLOSE, i + 1);
      double p1 = iMA(NULL, 0, SMA_PERIOD, 0, MODE_SMA, PRICE_CLOSE, i);
      double p2 = iMA(NULL, 0, SMA_PERIOD, 0, MODE_SMA, PRICE_CLOSE, i - 1);
      
      if(((p0 > p1) && (p1 < p2)) || ((p0 < p1) && (p1 > p2))) {
        buf_bend[i] = 1;
      } else {
        buf_bend[i] = 0;
      }
    } else {
      buf_bend[i] = 0;
    }
    
    //   .
    buf_count[i] = 0;
    
    if(i < work_period2) {
      for(int j = i + COUNT_PERIOD - 1; j >= i; j--) {
        if(buf_bend[j] > 0) buf_count[i]++;
      }
    } 
  }
  
  return(0);
}

